import { world, BlockPermutation } from "@minecraft/server";

const colors = [
    "white", "black", "red", "blue", "green", "yellow", "orange", "purple", 
    "cyan", "brown", "pink", "gray", "light_blue", "silver", "lime", "magenta"
];

world.beforeEvents.worldInitialize.subscribe(eventData => {
    colors.forEach(color => {
        eventData.blockComponentRegistry.registerCustomComponent(`tunekeshi:on_interact_${color}`, {
            onPlayerInteract: e => {
                const { block, player } = e;
                
                if (!player) return;  // playerがundefinedかどうかを確認

                const blockId = block.typeId;
                if (blockId.startsWith("tunekeshi:teleporter_")) {
                    player.addTag(color);
                }
            },
        });
    });
});